Index: console/src/resources/webconsole.war/ServerInfo.jsp
===================================================================
--- console/src/resources/webconsole.war/ServerInfo.jsp	(revision 73826)
+++ console/src/resources/webconsole.war/ServerInfo.jsp	(working copy)
@@ -1,3 +1,5 @@
+<?xml version="1.0" encoding="UTF-8" ?>
+<%@ page language="java" pageEncoding="UTF-8" contentType="text/html;charset=UTF-8" %>
 <%--
  |
  |  Author: Sacha Labourey    (sacha@jboss.org)
@@ -6,87 +8,98 @@
  | See terms of license at gnu.org.
  +--%>
 <%@ taglib uri="/webconsole" prefix="jb" %>
+
 <jb:mbean id="server" mbean='jboss.system:type=Server' intf="org.jboss.system.server.ServerImplMBean" />
 <jb:mbean id="serverInfo" mbean='jboss.system:type=ServerInfo' intf="org.jboss.system.server.ServerInfoMBean" />
 <jb:mbean id="serverConfig" mbean='jboss.system:type=ServerConfig' intf="org.jboss.system.server.ServerConfigImplMBean" />
+<%@page import="org.jboss.console.I18n"%>
+<%@page import="org.jboss.varia.i18n.I18nUtil"%>
+
 <%
-   String myUrl = response.encodeURL(request.getRequestURI());
+	String myUrl = response.encodeURL(request.getRequestURI());
 %>
 <%!
 public String memSize (java.lang.Long lOctets)
 {
 	long octets = lOctets.longValue();
 	int ratio = 3*1024;
-	String unit = "";
+	String fmt = "{0} "; //$NON-NLS-1$
 	if (octets > ratio)
 	{
-	   unit = "KB";
+	   fmt = I18n.gettext("{0} KB"); //$NON-NLS-1$
 	   octets/=1024;	
 	   
 		if (octets > ratio)
 		{
-		   unit = "MB";
+		   fmt = I18n.gettext("{0} MB"); //$NON-NLS-1$
 		   octets/=1024;	
 		   
 			if (octets > ratio)
 			{
-			   unit = "GB";
+	   		fmt = I18n.gettext("{0} GB"); //$NON-NLS-1$
 			   octets/=1024;	
 			   
 				if (octets > ratio)
 				{
-				   unit = "TB";
-				   octets/=1024;	
+				   fmt = I18n.gettext("{0} TB"); //$NON-NLS-1$
+				   octets/=1024;
 				}
 			}
 		}
 	}
 	
-	return octets + " " + unit;
+	return java.text.MessageFormat.format(fmt, new Object[] {new Long(octets)});
 }
 %>
-<?xml version="1.0" encoding="iso-8859-1"?>
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <html xmlns="http://www.w3.org/1999/xhtml">
 <head>
-<title>JBoss Management Console - Server Information</title>
-<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
+<title>${messages["JBoss Management Console - Server Information"]}</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
 <link rel="StyleSheet" href="css/jboss.css" type="text/css"/>
 </head>
 <body>
 <!-- header begin -->
-	<img src="images/logo.gif" alt="JBoss" id="logo" width="226" height="105" />
+	<img src="images/logo.gif" alt="${messages['JBoss']}" id="logo" width="226" height="105" />
 	<div id="header">
 		&nbsp;</div>
 	<div id="navigation_bar">
 	</div>
 <!-- header end -->
+<div id="language">
+
+<jsp:include page="localeselect.jsp">
+   <jsp:param name="from" value="ServerInfo.jsp" />	
+</jsp:include>
+
+</div>
 <hr class="hide"/>
 	<center>
 	<div id="content">
 		<div class="content_block" style="width: 100%; height: 247">
-			<h3>JBoss&trade; Application Server</h3>
+			<h3>${messages["JBoss&trade; Application Server"]}</h3>
 					<p>&nbsp;</p>
 				<table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="95%" align="center" id="AutoNumber1">
                   <tr>
                     <td width="50%" align="center" colspan="2">
-                    <h4 style="text-align: center"><font size="3">JBoss</font></h4>
+                    <h4 style="text-align: center"><font size="3">${messages["JBoss"]}</font></h4>
                     </td>
                   </tr>
                   <tr>
                     <td width="25%" align="center" valign="top">
-                    <h4>Version</h4>
-                    <p align="left"><font size="1"><b>Version: </b><%=server.getVersion()%></font></p>
-                    <p align="left"><font size="1"><b>Version Name: </b><%=server.getVersionName()%></font></p>
-                    <p align="left"><font size="1"><b>Built on: </b><%=server.getBuildDate()%></font>
+                    <p align="left"><font size="1"><b>${messages["Version: "]}</b><%=server.getVersion()%></font></p>
+                    <p align="left"><font size="1"><b>${messages["Version Name: "]}</b><%=server.getVersionName()%></font></p>
+                    <p align="left"><font size="1"><b>${messages["Built on: "]}</b><%=server.getBuildDate()%></font>
                     </td>
                     <td width="25%" align="center" valign="top">
-                    <h4>Environment</h4>
-                    <p align="left"><font size="1"><b>Start date: </b><%=server.getStartDate()%></font></p>
-                    <p align="left"><font size="1"><b>Host: </b><%=serverInfo.getHostName()%> (<%=serverInfo.getHostAddress ()%>)</font></p>
-                    <p align="left"><font size="1"><b>Base Location: </b><%=serverConfig.getServerBaseURL()%></font></p>
-                    <p align="left"><font size="1"><b>Base Location (local): </b><%=serverConfig.getServerBaseDir()%></font></p>
-                    <p align="left"><font size="1"><b>Running config: </b>'<%= serverConfig.getServerHomeDir().getName()%>'</font></td>
+                    <h4>${messages["Environment"]}</h4>
+						  <p align="left"><font size="1"><b>${messages["Start date: "]}${server.startDate}</font></p>
+                    <p align="left"><font size="1"><b>${messages["Host: "]}</b>${serverInfo.hostName} (${serverInfo.hostAddress})</font></p>
+                    <p align="left"><font size="1"><b>${messages["Default locale: "]}</b><%=java.util.Locale.getDefault()%></font></p>
+                    <p align="left"><font size="1"><b>${messages["User locale: "]}</b><%=I18nUtil.getRequestLocale()%></font></p>
+                    <p align="left"><font size="1"><b>${messages["Base Location: "]}</b><%=serverConfig.getServerBaseURL()%></font></p>
+                    <p align="left"><font size="1"><b>${messages["Base Location (local): "]}</b><%=serverConfig.getServerBaseDir()%></font></p>
+                    <p align="left"><font size="1"><b>${messages["Running config: "]}</b>'<%= serverConfig.getServerHomeDir().getName()%>'</font></td>
                   </tr>
 	
             </table>
@@ -94,27 +107,27 @@
 				<table border="1" cellpadding="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="95%" align="center" id="AutoNumber1">
                   <tr>
                     <td width="50%" align="center" colspan="2">
-                    <h4 style="text-align: center"><font size="3">JVM - Hardware</font></h4>
+                    <h4 style="text-align: center"><font size="3">${messages["JVM - Hardware"]}</font></h4>
                     </td>
                   </tr>
                   <tr>
                     <td width="25%" align="center" valign="top">
-                    <h4>Hardware</h4>
-                    <p align="left"><font size="1"><b>#CPU: </b><%=serverInfo.getAvailableProcessors()%></font></p>
-                    <p align="left"><font size="1"><b>OS: </b><%=serverInfo.getOSName()%> <%=serverInfo.getOSVersion()%> (<%=serverInfo.getOSArch()%>)</font></td>
+                    <h4>${messages["Hardware"]}</h4>
+                    <p align="left"><font size="1"><b>${messages["#CPU: "]}</b><%=serverInfo.getAvailableProcessors()%></font></p>
+                    <p align="left"><font size="1"><b>${messages["OS: "]}</b><%=serverInfo.getOSName()%> <%=serverInfo.getOSVersion()%> (<%=serverInfo.getOSArch()%>)</font></td>
                     <td width="25%" align="center" valign="top">
-                    <h4>JVM Environment</h4>
-                    <p align="left"><font size="1"><b>Free Memory: </b><%=memSize(serverInfo.getFreeMemory())%></font></p>
-                    <p align="left"><font size="1"><b>Max Memory: </b><%=memSize(serverInfo.getMaxMemory())%></font></p>
-                    <p align="left"><font size="1"><b>Total Memory: </b><%=memSize(serverInfo.getTotalMemory())%></font></p>
-                    <p align="left"><font size="1"><b>#Threads: </b><%=serverInfo.getActiveThreadCount()%></font></p>
-                    <p align="left"><font size="1"><b>JVM Version: </b><%=serverInfo.getJavaVMVersion()%> (<%=serverInfo.getJavaVMVendor()%>)</font></p>
-                    <p align="left"><font size="1"><b>JVM Name: </b><%=serverInfo.getJavaVMName()%></font></td>
+                    <h4>${messages["JVM Environment"]}</h4>
+                    <p align="left"><font size="1"><b>${messages["Free Memory: "]}</b><%=memSize(serverInfo.getFreeMemory())%></font></p>
+                    <p align="left"><font size="1"><b>${messages["Max Memory: "]}</b><%=memSize(serverInfo.getMaxMemory())%></font></p>
+                    <p align="left"><font size="1"><b>${messages["Total Memory: "]}</b><%=memSize(serverInfo.getTotalMemory())%></font></p>
+                    <p align="left"><font size="1"><b>${messages["#Threads: "]}</b><%=serverInfo.getActiveThreadCount()%></font></p>
+                    <p align="left"><font size="1"><b>${messages["JVM Version: "]}</b><%=serverInfo.getJavaVMVersion()%> (<%=serverInfo.getJavaVMVendor()%>)</font></p>
+                    <p align="left"><font size="1"><b>${messages["JVM Name: "]}</b><%=serverInfo.getJavaVMName()%></font></td>
                   </tr>
 
             </table>
 					<p>&nbsp;</p>
-            <p align="center"> <a href="<%=myUrl%>">Refresh</a></p>
+            <p align="center"> <a href="<%=myUrl%>">${messages["Refresh"]}</a></p>
 
 					<p>&nbsp;</p>
 					<p>&nbsp;</p>
@@ -128,7 +141,7 @@
 <hr class="hide"/>
 <!-- footer begin -->
 	<div id="footer">
-		<div id="credits">JBoss&trade; Management Console</div>
+		<div id="credits">${messages["JBoss&trade; Management Console"]}</div>
 		<div id="footer_bar">&nbsp;</div>
 	</div>
 <!-- footer end -->
Index: varia/.classpath
===================================================================
--- varia/.classpath	(revision 73826)
+++ varia/.classpath	(working copy)
@@ -1,9 +1,11 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <classpath>
 	<classpathentry excluding="org/jboss/jaxr/|org/jboss/jdo/castor/|org/jboss/tm/plugins/tyrex/|org/jboss/varia/stats/DataSourceInterceptor.java|org/jboss/varia/stats/DataSourceInterceptorMBean.java" kind="src" path="src/main"/>
+	<classpathentry excluding="org/jboss/test/" kind="src" path="src/test"/>
 	<classpathentry exported="true" kind="src" path="/cluster"/>
 	<classpathentry kind="src" path="/jbossmq"/>
 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+	<classpathentry kind="con" path="org.eclipse.jdt.junit.JUNIT_CONTAINER/3"/>
 	<classpathentry kind="lib" path="/thirdparty/apache-bsf/lib/bsf.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/hsqldb/lib/hsqldb.jar"/>
 	<classpathentry kind="lib" path="/tools/lib/ant.jar"/>
@@ -19,5 +21,8 @@
 	<classpathentry kind="lib" path="/thirdparty/juddi/lib/juddi.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/beanshell/lib/bsh.jar"/>
 	<classpathentry kind="lib" path="/thirdparty/jboss/jboss-deployers/lib/jboss-deployers-client.jar" sourcepath="/thirdparty/jboss/jboss-deployers/lib/jboss-deployers-client-sources.jar"/>
+	<classpathentry kind="lib" path="/thirdparty/jboss/web/lib/el-api.jar" sourcepath="/thirdparty/jboss/web/lib/jbossweb-src.zip"/>
+	<classpathentry kind="lib" path="/thirdparty/sun-servlet/lib/jsp-api.jar"/>
+	<classpathentry kind="lib" path="/thirdparty/jboss/test/lib/jboss-test.jar" sourcepath="/extra/work-clebert/workspaces/jtest/jboss-test/src"/>
 	<classpathentry kind="output" path="output/eclipse-classes"/>
 </classpath>
Index: varia/src/test/org/jboss/varia/i18n/I18nUtilTest.java
===================================================================
--- varia/src/test/org/jboss/varia/i18n/I18nUtilTest.java	(revision 0)
+++ varia/src/test/org/jboss/varia/i18n/I18nUtilTest.java	(revision 0)
@@ -0,0 +1,30 @@
+package org.jboss.varia.i18n;
+
+import java.text.MessageFormat;
+import java.util.Locale;
+
+import junit.framework.TestCase;
+
+public class I18nUtilTest extends TestCase
+{
+
+   public I18nUtilTest(String name)
+   {
+      super(name);
+   }
+
+   public void testToLocale()
+   {
+      assertEquals(Locale.ENGLISH, I18nUtil.toLocale("en")); //$NON-NLS-1$
+      assertEquals(new Locale("en", "AU", "LINUX"), I18nUtil.toLocale("en_AU_LINUX"));    //$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$//$NON-NLS-4$
+      assertEquals(new Locale("en", "AU"), I18nUtil.toLocale("en_AU"));  //$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$
+      assertEquals(new Locale("sr", "LATN"), I18nUtil.toLocale("sr_LATN"));  //$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$
+   }
+
+   public void testMessageFormat() throws Exception
+   {
+      String result = MessageFormat.format("I''m sorry {0}, I''m afraid I can''t do that. '{'{1}'}'", "Dave", "HAL");   //$NON-NLS-1$//$NON-NLS-2$//$NON-NLS-3$
+      assertEquals("I'm sorry Dave, I'm afraid I can't do that. {HAL}", result); //$NON-NLS-1$
+   }
+
+}

Index: varia/src/main/org/jboss/varia/i18n/I18nServletContextListener.java
===================================================================
--- varia/src/main/org/jboss/varia/i18n/I18nServletContextListener.java	(revision 0)
+++ varia/src/main/org/jboss/varia/i18n/I18nServletContextListener.java	(revision 0)
@@ -0,0 +1,63 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.varia.i18n;
+
+import javax.el.BeanELResolver;
+import javax.el.CompositeELResolver;
+import javax.el.ELContextEvent;
+import javax.el.ELContextListener;
+import javax.el.ELResolver;
+import javax.el.ListELResolver;
+import javax.el.MapELResolver;
+import javax.el.ResourceBundleELResolver;
+import javax.servlet.ServletContext;
+import javax.servlet.ServletContextEvent;
+import javax.servlet.ServletContextListener;
+import javax.servlet.jsp.JspApplicationContext;
+import javax.servlet.jsp.JspFactory;
+
+import org.jboss.logging.Logger;
+
+/**
+ * This servlet filter registers the BundleResolver with the JSP context.
+ * @see BundleResolver
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $$Revision: $$
+ */
+public class I18nServletContextListener implements ServletContextListener
+{
+   
+   private static final Logger log = Logger.getLogger(I18nServletContextListener.class);
+
+   public void contextDestroyed(ServletContextEvent arg0)
+   {
+      // nop
+   }
+
+   // may not be needed???
+//   private static ELResolver createELResolver()
+//   {
+//      CompositeELResolver resolver = new CompositeELResolver();
+//      resolver.add( new BundleResolver() );
+//      resolver.add( new MapELResolver() );
+//      resolver.add( new ListELResolver() );
+//      resolver.add( new ResourceBundleELResolver() );
+//      resolver.add( new BeanELResolver() );
+//      return resolver;
+//   }
+
+
+   public void contextInitialized(ServletContextEvent servletContextEvent)
+   {
+      ServletContext servletContext = servletContextEvent.getServletContext();
+      JspApplicationContext jspContext = JspFactory.getDefaultFactory().getJspApplicationContext(servletContext);
+      jspContext.addELResolver(new BundleResolver());
+//      jspContext.addELResolver(createELResolver());
+      log.info("BundleResolver registered: "+servletContext.getContextPath()); //$NON-NLS-1$
+   }
+
+}

Index: varia/src/main/org/jboss/varia/i18n/MessageFormatResolver.java
===================================================================
--- varia/src/main/org/jboss/varia/i18n/MessageFormatResolver.java	(revision 0)
+++ varia/src/main/org/jboss/varia/i18n/MessageFormatResolver.java	(revision 0)
@@ -0,0 +1,47 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.varia.i18n;
+
+import java.text.MessageFormat;
+import java.util.ArrayList;
+import java.util.List;
+
+/**
+ * Resolves strings by accumulating the format arguments and then formatting 
+ * the pattern and its arguments with MessageFormat when toString() is called.  
+ * If no arguments are supplied, the pattern string is simply returned verbatim.
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $$Revision: $$
+ */
+public class MessageFormatResolver
+{
+   private static final org.jboss.logging.Logger log = org.jboss.logging.Logger.getLogger(MessageFormatResolver.class);
+   
+   private final String pattern;
+
+   private final List<Object> args = new ArrayList<Object>();
+
+   public MessageFormatResolver(String pattern)
+   {
+      log.trace("<init>('"+pattern+"')"); //$NON-NLS-1$ //$NON-NLS-2$
+      this.pattern = pattern;
+   }
+
+   public void addArg(Object arg)
+   {
+      log.trace("addArg(["+arg.getClass().getName()+"] '"+arg+"')"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+      args.add(arg);
+   }
+
+   public String toString()
+   {
+      if (args.size() == 0)
+         return pattern;
+      return MessageFormat.format(pattern, args.toArray());
+   }
+
+}
\ No newline at end of file

Index: varia/src/main/org/jboss/varia/i18n/FallbackResourceBundle.java
===================================================================
--- varia/src/main/org/jboss/varia/i18n/FallbackResourceBundle.java	(revision 0)
+++ varia/src/main/org/jboss/varia/i18n/FallbackResourceBundle.java	(revision 0)
@@ -0,0 +1,51 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.varia.i18n;
+
+import java.util.Enumeration;
+import java.util.MissingResourceException;
+import java.util.ResourceBundle;
+
+/**
+ * This decorator ResourceBundle quietly falls back on the key when 
+ * a key is missing from the underlying resource bundle, since English
+ * strings may appear in the resource bundle, but otherwise should come 
+ * from the source code.
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $Revision: $
+ */
+class FallbackResourceBundle extends ResourceBundle
+{
+
+   private final ResourceBundle bundle;
+
+   public FallbackResourceBundle(ResourceBundle bundle)
+   {
+      this.bundle = bundle;
+      
+   }
+
+   @Override
+   public Enumeration<String> getKeys()
+   {
+      return bundle.getKeys();
+   }
+
+   @Override
+   protected Object handleGetObject(String key)
+   {
+      try
+      {
+         return bundle.getObject(key);
+      }
+      catch (MissingResourceException e)
+      {
+         return key;
+      }
+   }
+
+}

Index: varia/src/main/org/jboss/varia/i18n/I18nFilter.java
===================================================================
--- varia/src/main/org/jboss/varia/i18n/I18nFilter.java	(revision 0)
+++ varia/src/main/org/jboss/varia/i18n/I18nFilter.java	(revision 0)
@@ -0,0 +1,172 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.varia.i18n;
+
+import java.io.IOException;
+import java.util.Locale;
+import java.util.MissingResourceException;
+import java.util.ResourceBundle;
+
+import javax.servlet.Filter;
+import javax.servlet.FilterChain;
+import javax.servlet.FilterConfig;
+import javax.servlet.ServletException;
+import javax.servlet.ServletRequest;
+import javax.servlet.ServletResponse;
+import javax.servlet.http.Cookie;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletRequestWrapper;
+import javax.servlet.http.HttpServletResponse;
+
+import org.jboss.logging.Logger;
+
+
+/**
+ * This servlet filter is responsible for 
+ * (a) keeping the request locale in a thread-local for later use 
+ * by i18n classes, and 
+ * (b) loading the localised resource bundle for the current request, 
+ * and storing it as a request attribute 'messages' to allow EL lookups 
+ * such as ${messages["my key"]}. 
+ * 
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $Revision: $
+ */
+public class I18nFilter implements Filter
+{
+
+   static final Logger log = Logger.getLogger(I18nFilter.class);
+   private String bundleName = null;
+
+   public void destroy()
+   {
+      // nop
+   }
+
+   
+   public void init(FilterConfig config) throws ServletException
+   {
+      String bundle = config.getInitParameter("bundle"); //$NON-NLS-1$
+      setBundleName(bundle);
+      log.debug("Using bundle "+bundle+" for "+config.getServletContext().getContextPath()); //$NON-NLS-1$ //$NON-NLS-2$
+   }
+   
+   private void setBundleName(String bundleName)
+   {
+      this.bundleName = bundleName;
+   }
+
+   public void doFilter(ServletRequest req, ServletResponse resp, FilterChain chain) throws IOException,
+         ServletException
+   {
+      HttpServletRequest httpReq = (HttpServletRequest)req;
+      HttpServletResponse httpResp = (HttpServletResponse) resp;
+      String path = httpReq.getServletPath();
+      String uri;
+      if(httpReq.getQueryString() == null)
+         uri = httpReq.getRequestURI();
+      else
+         uri = httpReq.getRequestURI()+"?"+httpReq.getQueryString(); //$NON-NLS-1$
+      if(log.isTraceEnabled())
+      {
+         log.trace("doFilter called for "+uri); //$NON-NLS-1$
+      }
+      //I18nUtil.reloadBundlesHack();
+      ResourceBundle bundle;
+      Locale localeFromCookie = null;
+      Cookie[] cookies = httpReq.getCookies();
+      if (cookies != null)
+      {
+         for (int i = 0; i < cookies.length; i++)
+         {
+            Cookie cookie = cookies[i];
+            if("locale".equals(cookie.getName())) //$NON-NLS-1$
+            {
+               localeFromCookie = I18nUtil.toLocale(cookie.getValue());
+               if(log.isTraceEnabled())
+               {
+                  log.trace("Using locale from cookie: "+localeFromCookie); //$NON-NLS-1$
+               }
+            }
+         }
+      }
+      final Locale locale;
+      if (localeFromCookie != null)
+      {
+         locale = localeFromCookie;
+      }
+      else
+      {
+         //      req.getLocales()
+         locale = req.getLocale();
+      }
+      try 
+      {
+    	  bundle = ResourceBundle.getBundle(bundleName, locale);
+          if(locale.getLanguage().equals(Locale.ENGLISH.getLanguage()))
+          {
+             if(log.isTraceEnabled())
+             {
+                log.trace("locale is "+locale+"; using FallbackResourceBundle"); //$NON-NLS-1$ //$NON-NLS-2$
+             }
+             bundle = new FallbackResourceBundle(bundle);
+          }
+      } 
+      catch (MissingResourceException e) 
+      {
+         if(locale.getLanguage().equals(Locale.ENGLISH.getLanguage()))
+         {
+            if(log.isTraceEnabled())
+            {
+               log.trace("locale is "+locale+"; using IdentityResourceBundle"); //$NON-NLS-1$ //$NON-NLS-2$
+            }
+            bundle = new IdentityResourceBundle();
+         }
+         else
+         {
+            if(log.isTraceEnabled())
+            {
+               log.trace("locale is "+locale+"; using MungingResourceBundle"); //$NON-NLS-1$ //$NON-NLS-2$
+            }
+            bundle = new MungingResourceBundle(locale);
+         }
+      }
+
+      req.setCharacterEncoding("UTF-8"); //$NON-NLS-1$
+      resp.setCharacterEncoding("UTF-8"); //$NON-NLS-1$
+      bundle = LoggingResourceBundle.wrap(bundle, bundleName, locale);
+      req.setAttribute("messages", bundle); //$NON-NLS-1$
+      I18nUtil.setRequestLocale(locale);
+      httpReq.getSession().setAttribute("locale", locale); //$NON-NLS-1$
+      HttpServletRequestWrapper wrapReq = new HttpServletRequestWrapper(httpReq)
+      {
+         public Locale getLocale() { return locale; }
+      };
+      if (path != null && path.endsWith(".html")) //$NON-NLS-1$
+      {
+         String jsp;
+         if(path.endsWith("/index.html")) //$NON-NLS-1$
+         {
+            jsp = "."; //$NON-NLS-1$
+         }
+         else
+         {
+            int slash = path.lastIndexOf('/');
+            jsp = path.substring(slash+1, path.length()-".html".length())+".jsp"; //$NON-NLS-1$ //$NON-NLS-2$
+         }
+         
+         httpResp.setStatus(HttpServletResponse.SC_MOVED_PERMANENTLY);
+         httpResp.addHeader("Location", jsp); //$NON-NLS-1$
+      }
+      else
+      {
+         chain.doFilter(wrapReq, resp);
+      }
+      I18nUtil.clearRequestLocale();
+   }
+
+}

Index: varia/src/main/org/jboss/varia/i18n/MungingResourceBundle.java
===================================================================
--- varia/src/main/org/jboss/varia/i18n/MungingResourceBundle.java	(revision 0)
+++ varia/src/main/org/jboss/varia/i18n/MungingResourceBundle.java	(revision 0)
@@ -0,0 +1,52 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.varia.i18n;
+
+import java.util.Enumeration;
+import java.util.Locale;
+import java.util.NoSuchElementException;
+import java.util.ResourceBundle;
+
+/**
+ * Decorates an underlying ResourceBundle so that missing keys are handled 
+ * by munging the (English) key instead of throwing MissingResourceException. 
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $$Revision: $$
+ */
+class MungingResourceBundle extends ResourceBundle
+{
+
+   private final Locale locale;
+
+   public MungingResourceBundle(Locale locale)
+   {
+      this.locale = locale;
+   }
+
+   @Override
+   public Enumeration<String> getKeys()
+   {
+      return new Enumeration<String>()
+      {
+         public boolean hasMoreElements()
+         {
+            return false;
+         }
+         public String nextElement()
+         {
+            throw new NoSuchElementException();
+         }
+      };
+   }
+
+   @Override
+   protected Object handleGetObject(String key)
+   {
+      return I18nUtil.munge(key, locale);
+   }
+
+}

Index: varia/src/main/org/jboss/varia/i18n/LoggingResourceBundle.java
===================================================================
--- varia/src/main/org/jboss/varia/i18n/LoggingResourceBundle.java	(revision 0)
+++ varia/src/main/org/jboss/varia/i18n/LoggingResourceBundle.java	(revision 0)
@@ -0,0 +1,71 @@
+/*
+ * JBoss, the OpenSource J2EE webOS
+ * 
+ * Distributable under LGPL license.
+ * See terms of license at gnu.org.
+ */
+package org.jboss.varia.i18n;
+
+import java.util.ArrayList;
+import java.util.Enumeration;
+import java.util.List;
+import java.util.Locale;
+import java.util.MissingResourceException;
+import java.util.ResourceBundle;
+
+/**
+ * Simply decorates a ResourceBundle to add debug logging of contained keys and lookups.
+ * @author <a href="mailto:sflaniga@redhat.com">Sean Flanigan</a>
+ * @version $$Revision: $$
+ */
+public class LoggingResourceBundle extends ResourceBundle
+{
+   private static final org.jboss.logging.Logger log = org.jboss.logging.Logger.getLogger(LoggingResourceBundle.class);
+
+   private final ResourceBundle original;
+
+   private String locale;
+
+   public static ResourceBundle wrap(ResourceBundle original, String bundleName, Locale locale)
+   {
+      if (log.isTraceEnabled())
+         return new LoggingResourceBundle(original, bundleName, locale);
+      else
+         return original;
+   }
+
+   private LoggingResourceBundle(ResourceBundle original, String bundleName, Locale locale)
+   {
+      this.original = original;
+      this.locale = locale.toString();
+      List<String> keys = new ArrayList<String>();
+      for (Enumeration<String> e = original.getKeys(); e.hasMoreElements();)
+      {
+         String key = e.nextElement();
+         keys.add(key);
+      }
+      log.trace(bundleName+" keys: "+keys); //$NON-NLS-1$
+   }
+
+   @Override
+   public Enumeration<String> getKeys()
+   {
+      return original.getKeys();
+   }
+
+   @Override
+   protected Object handleGetObject(String key)
+   {
+      log.trace("get: \"" + key + '"'); //$NON-NLS-1$
+      try
+      {
+         return original.getObject(key);
+      }
+      catch (MissingResourceException e)
+      {
+         log.warn("get FAILED in [" + locale + "]: \"" + key + '"'); //$NON-NLS-1$ //$NON-NLS-2$
+         throw e;
+      }
+   }
+
+}

